HDU3308-LCIS-线段树区间合并

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3308

题目大意:给n个数,两种操作

1:U  a,b   更新第a个为b (从0开始)

2:Q  a,b  查询 a,b之间LCIS(最长连续递增子序列)的长度。

其实也可以说是个模板题;三个变量保存数据ls,rs,ms分别保存从左端点开始的最长连续上升子序列,从右端点开始的最长连续上升子序列,以及这个区间的最长连续上升子序列;唯一不同的就是这里得判断一下是否能够合并;即增加一个比较如果num[mid]<num[mid+1](num数组保存的是输入的数据),说明可以合并;

直接代码:

#include<iostream>
#include<string>
#include<cstdio>
#include<cstring>
#include<queue>
#include<map>
#include<cmath>
#include<stack>
#include<set>
#include<vector>
#include<algorithm>
#define LL long long
#define inf 1<<30
#define s(a) scanf("%d",&a)
#define CL(a,b) memset(a,b,sizeof(a))
using namespace std;
const int N=100005;
int n,a,b,m;
int num[N];
int ls[N<<2],rs[N<<2],ms[N<<2];
void Push_Up(int l,int r,int rt)
{
    ls[rt]=ls[rt<<1];
    rs[rt]=rs[rt<<1|1];
    ms[rt]=max(ms[rt<<1],ms[rt<<1|1]);
    int mid=(l+r)>>1;
    if(num[mid]<num[mid+1]){        //  判断是否能够合并;
        if(ls[rt]==mid-l+1) ls[rt]+=ls[rt<<1|1];
        if(rs[rt]==r-mid) rs[rt]+=rs[rt<<1];
        ms[rt]=max(ms[rt],(ls[rt<<1|1]+rs[rt<<1]));
    }
}
void Build(int l,int r,int rt)
{
    if(l==r){
        ls[rt]=rs[rt]=ms[rt]=1;
        return ;
    }
    int mid=(l+r)>>1;
    Build(l,mid,rt<<1);
    Build(mid+1,r,rt<<1|1);
    Push_Up(l,r,rt);
}
void Updata(int p,int l,int r,int rt)
{
    if(l==r) return ;
    int mid=(l+r)>>1;
    if(p<=mid) Updata(p,l,mid,rt<<1);
    else Updata(p,mid+1,r,rt<<1|1);
    Push_Up(l,r,rt);
}
int Query(int L,int R,int l,int r,int rt)
{
    if(L<=l&&R>=r) return ms[rt];           //  完全包含在内;
    int mid=(l+r)>>1;
    if(R<=mid) return Query(L,R,l,mid,rt<<1);   //  这里和区间合并模板有区别,不是子集和,只有完全符合区间才会查询;
    if(L>mid) return Query(L,R,mid+1,r,rt<<1|1);    //  三种情况; 逐一判断,取最大的;
    int ta,tb;
    ta=Query(L,R,l,mid,rt<<1);
    tb=Query(L,R,mid+1,r,rt<<1|1);
    int ans=max(ta,tb);
    if(num[mid]<num[mid+1]){        //  同27行;(第三种情况)
        int tmp;
        tmp=min(mid-L+1,rs[rt<<1])+min(R-mid,ls[rt<<1|1]);      //  这个地方要特别注意,不能直接相加,得符合查询区间;
        ans=max(ans,tmp);
    }
    return ans;
}
int main()
{
    int t;
    s(t);
    char ch[10];
    while(t--){
        s(n);s(m);
        for(int i=1;i<=n;i++) s(num[i]);
        Build(1,n,1);
        while(m--){
            scanf("%s",&ch);
            if(ch[0]=='U'){
                s(a);s(b);
                num[a+1]=b;
                Updata(a+1,1,n,1);
            }else{
                s(a);s(b);
                printf("%d\n",Query(a+1,b+1,1,n,1));
            }
        }
    }
    return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-11-05 19:41:54

HDU3308-LCIS-线段树区间合并的相关文章

HDU 3308 LCIS (线段树区间合并)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3308 题目很好懂,就是单点更新,然后求区间的最长上升子序列. 线段树区间合并问题,注意合并的条件是a[mid + 1] > a[mid],写的细心点就好了. 1 #include <iostream> 2 #include <cstring> 3 #include <cstdio> 4 using namespace std; 5 const int MAXN = 1

HDU 3308 LCIS(线段树区间合并)

Problem Description Given n integers. You have two operations: U A B: replace the Ath number by B. (index counting from 0) Q A B: output the length of the longest consecutive increasing subsequence (LCIS) in [a, b]. Input T in the first line, indicat

HDU 3308 LCIS(最长连续上升子序列)(线段树区间合并)

题意:给你n个整数,有两种操作,U A B把第A个数变成B,Q A B查询区间[A,B]的最长连续上升序列. 思路:还是查询和更新操作,而且也是询问区间中满足条件的连续最长区间 ,所以是线段树区间合并类型的题,通法是开三棵线段树,一个记录此区间内的LCIS的最长长度,一个记录从左边第一个数开始的LCIS长度,另一个记录从右边最后一个数结尾的LCIS长度.然后试图找到父亲与儿子关系维护的递推关系式就好 本题中的递推关系是: 1. 左儿子最右边的值 < 右儿子最左边的值 lmx = (左儿子的lmx

HDU3308 线段树区间合并

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3308 ,简单的线段树区间合并. 线段树的区间合并:一般是要求求最长连续区间,在PushUp()函数中实现区间合并操作. 解法: 由于对于一个区间的最长序列来说,最优解要么完全在左半序列,要么完全在右半序列,要么跨越中间点.所以可以构造线段树,维护结点区间的三个元素:最长上升前缀len[].l,最长上升后缀len[].r,最长上升序列len[].m.所以对于一个区间来说,有这样两种情况: 1. 左儿子

hdu 3308(线段树区间合并)

LCIS Time Limit: 6000/2000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 6069    Accepted Submission(s): 2635 Problem Description Given n integers.You have two operations:U A B: replace the Ath number by B. (index

HDU 3911 Black And White(线段树区间合并)

Problem Description There are a bunch of stones on the beach; Stone color is white or black. Little Sheep has a magic brush, she can change the color of a continuous stone, black to white, white to black. Little Sheep like black very much, so she wan

HDU 5316 Magician(线段树区间合并入门)

本文纯属原创,转载请注明出处谢谢.http://blog.csdn.net/zip_fan. 题目传送门:http://acm.hdu.edu.cn/showproblem.php?pid=5316 Time Limit: 18000/9000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Problem Description Fantasy magicians usually gain their ability

poj3667 线段树 区间合并

1 //Accepted 3728 KB 1079 ms 2 //线段树 区间合并 3 #include <cstdio> 4 #include <cstring> 5 #include <iostream> 6 #include <queue> 7 #include <cmath> 8 #include <algorithm> 9 using namespace std; 10 /** 11 * This is a document

hdu3911 线段树 区间合并

1 //Accepted 3911 750MS 9872K 2 //线段树 区间合并 3 #include <cstdio> 4 #include <cstring> 5 #include <iostream> 6 #include <queue> 7 #include <cmath> 8 #include <algorithm> 9 using namespace std; 10 /** 11 * This is a documen

线段树 区间合并

poj3667 Hotel 区间合并入门题,照着代码打的, 题意:1 a:询问是不是有连续长度为a的空房间,有的话住进最左边       2 a b:将[a,a+b-1]的房间清空思路:记录区间中最长的空房间,开三个数组,msum[rt]表示节点rt内连续的1的个数的最大值,lsum[rt]表示从节点rt左端点开始连续1的个数,rsum[rt]表示从节点rt右端点开始连续1的个数..线段树操作:update:区间替换 query:询问满足条件的最左端点 1 #include<iostream>